<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

<div class="container mt-4">
  <h1 class="mb-4">Movie Library</h1>

  <div class="row mb-3">
    <div class="col-12 col-md-6">
      <input type="text" class="form-control" placeholder="Filter by title" name="filterInput" [(ngModel)]="listFilter">
    </div>
    <div class="col-12 col-md-6">
      <div class="d-flex align-items-center h-100">
        <div class="btn-group watched-filter-group ml-1" role="group" aria-label="Watched Filter">
          <button type="button" class="btn btn-custom" [ngClass]="{'btn-custom-selected': watchedFilter === 'all'}"
            (click)="setWatchedFilter('all')">All</button>
          <button type="button" class="btn btn-custom" [ngClass]="{'btn-custom-selected': watchedFilter === 'watched'}"
            (click)="setWatchedFilter('watched')">Watched</button>
          <button type="button" class="btn btn-custom"
            [ngClass]="{'btn-custom-selected': watchedFilter === 'unwatched'}"
            (click)="setWatchedFilter('unwatched')">Unwatched</button>
        </div>
      </div>
    </div>
  </div>
  <div class="row">
    <div class="col-12">
      <div class="d-flex justify-content-start mb-3">
        <mat-slide-toggle (change)="toggleView()" [checked]="viewMode === 'grid'">
          {{ viewMode === 'table' ? 'Table' : 'Grid' }} View
        </mat-slide-toggle>
      </div>
    </div>
  </div>

  <table class="table" *ngIf="viewMode === 'table'">
    <thead>
      <tr>
        <th style="text-align: center;">Poster</th>
        <th style="text-align: center;">Title</th>
        <th style="text-align: center;">Description</th>
        <th style="text-align: center;" title="TMDB rating">TMDB</th>
        <th style="text-align: center;"><span class="fa fa-star checked" style="color:darkorange"
            title="Your rating"></span></th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let movie of filteredMovies">
        <td>
          <div class="poster-container">
            <img [src]="movie.posterUrl" alt="Movie Poster" class="poster-image" [style.width.px]="imageWidth"
              [style.margin.px]="imageMargin">
            <i class="fa-sharp fa-solid fa-trash text-danger delete-icon" (click)="deleteMovie(movie)" title="Delete movie"></i>
          </div>
        </td>
        <td>
          {{ movie.title }} ({{ movie.release}})
        </td>
        <td>{{ movie.description }}</td>
        <td style="white-space: nowrap;">
          <span class="fa fa-star checked" style="color:cornflowerblue"></span>
          {{ movie.tmdbRating | number: '1.1-1' }}
        </td>
        <td style="white-space: nowrap;">
          <a (click)="openRatingDialog(movie)" class="no-link-pointer-cursor">
            <span class="fa fa-star checked" style="color:darkorange"></span>
            {{ movie.personalRating ? (movie.personalRating | number: '1.1-1') : 'Rate!'}}
          </a>
        </td>
      </tr>
    </tbody>
  </table>

  
  <div class="row" *ngIf="viewMode === 'grid'">
    <div class="col-4 col-md-2 mb-4" *ngFor="let movie of filteredMovies">
      <div class="card">
        <div class="card-img-container">
          <img [src]="movie.posterUrl" alt="Movie Poster" class="card-img-top">
          <i class="fa-sharp fa-solid fa-expand expand-icon" (click)="openDetailsDialog(movie)"></i>
        </div>
        <div class="card-body ">
          <h5 class="rating-container custom-card-body">
            <div>
              <span class="rating">
                <span class="fa fa-star checked" style="color:cornflowerblue" title="TMDB Rating"></span>
                {{ movie.tmdbRating | number: '1.1-1' }}
              </span>
              <a *ngIf="movie.watched" (click)="openRatingDialog(movie)" class="no-link-pointer-cursor rating">
                <span class="fa fa-star checked" style="color:darkorange" title="Personal Rating"></span>
                {{ movie.personalRating ? (movie.personalRating | number: '1.1-1') : '--'}}
              </a>
            </div>
            <div>
              <span class="fa-sharp fa-solid fa-trash text-danger grid-delete-icon" (click)="deleteMovie(movie)" title="Delete movie"></span>
            </div>
          </h5>
        </div>
        <div class="watched-triangle" [ngClass]="{'watched': movie.watched}" (click)="toggleWatched(movie)"></div>
        <span class="watched-icon fa"
          [ngClass]="{'fa-eye': movie.watched, 'fa-eye-slash': !movie.watched, 'always-visible': movie.watched}"
          (click)="toggleWatched(movie)"></span>
      </div>
    </div>
  </div>

  <p *ngIf="!movies.length">No movies found.</p>
</div>